#!/usr/bin/perl
# SysWatch v1.0-BSD [19990522] by Chris Martino <chris@weirdo.net>
# You can download the latest version of this script as well as 
# other scripts at http://www.weirdo.net/scripts/

### Configuration Area ###

# These are the partition devices show when issuing the 
# 'df' command, you see them in the 1st column, something 
# like /dev/wd0s1a.  Leave the /dev/ part off and just use
# wd0s1a.  If you don't have a device listed leave it as ""
$rootdev = "wd0s1a";	# The / device
$homedev = "wd0s1h";	# The /home device
$usrdev = "wd0s1g";	# The /usr device
$vardev = "wd0s1f";	# The /var/device

# Memory/Swap info.  You must plug these in manually, as I
# haven't found a command to grab this info from the system.
$memory = "64";		# How much memory, in megabytes.
$swap = "128";		# How much swap, in megabytes.

# URL to the greendot.gif image.
$image = 'greendot.gif';

# [1/0] What information do you want the CGI to display?
# 1 = show info ; 0 = don't show info.
$showdrivemap = 1; 	# Do you want to show the drivemaps?
$showwhat = 1;		# Do you want to show what people are doing?
$showhogs = 1;		# Do you want to show what is taking up
			# alot of resources?

### End Configuration ###

### Do NOT edit below here unless you know what you're doing!! ###

$sysname = `hostname`;
$sysos = `uname -sr`;
$uptime = `uptime`;
$tmptop = '/tmp/tmptop';
$tmpw = '/tmp/tmpw';

if ( $rootdev ne "" ) {
	$cutroot = `df | grep $rootdev | cut -c44-46`;
}
if ( $homedev ne "" ) {
	$cuthome = `df | grep $homedev | cut -c44-46`;
}
if ( $usrdev ne "" ) {
	$cutusr = `df | grep $usrdev | cut -c44-46`;
}
if ( $vardev ne "" ) {
	$cutvar = `df | grep $vardev | cut -c45-46`;
}
if ( $rootdev ne "" ) {
	$cutrootused = `df -k | grep $rootdev | cut -c26-30`;
}
if ( $homedev ne "" ) {
	$cuthomeused = `df -k | grep $homedev | cut -c24-30`;
}
if ( $usrdev ne "" ) {
	$cutusrused = `df -k | grep $usrdev | cut -c24-30`;
}
if ( $vardev ne "" ) {
	$cutvarused = `df -k | grep $vardev | cut -c26-30`;
}
if ( $rootdev ne "" ) {
	$cutrootavail = `df -k | grep $rootdev | cut -c35-39`;
}
if ( $homedev ne "" ) {
	$cuthomeavail = `df -k | grep $homedev | cut -c33-39`;
}
if ( $usrdev ne "" ) {
	$cutusravail = `df -k | grep $usrdev | cut -c33-39`;
}
if ( $vardev ne "" ) {
	$cutvaravail = `df -k | grep $vardev | cut -c35-39`;
}
if ( $rootdev ne "" ) {
	$cutroottotal = `df -k | grep $rootdev | cut -c17-21`;
}
if ( $homedev ne "" ) {
	$cuthometotal = `df -k | grep $homedev | cut -c15-21`;
}
if ( $usrdev ne "" ) {
	$cutusrtotal = `df -k | grep $usrdev | cut -c15-21`;
}
if ( $vardev ne "" ) {
	$cutvartotal = `df -k | grep $vardev | cut -c17-21`;
}

chomp($uptime);
chomp($sysname);
chomp($sysos);
chomp($cuthome);
chomp($cutusr);
chomp($cutroot);
chomp($cutvar);

chomp($cutrootused);
chomp($cuthomeused);
chomp($cutusrused);
chomp($cutvarused);

chomp($cutrootavail);
chomp($cuthomeavail);
chomp($cutusravail);
chomp($cutvaravail);

chomp($cutroottotal);
chomp($cutusrtotal);
chomp($cuthometotal);
chomp($cutvartotal);

open(OUTF,">>$tmptop");
	print OUTF `top -o cpu -d1 10 |grep -A7 PID`;
close(OUTF);

open(OUTF,">>$tmpw");
	print OUTF `w`;
close(OUTF);

print "Content-type: text/html\n\n";

print <<EndHTML;
<html>
<head>
<title>$sysname system information</title>
</head>
<body bgcolor=#000000 text="#ffffff">
<font face="courier, courier new, fixed, arial, helvetica" size="2">
<br>
<p>
<center>
<table cellpadding="0" cellspacing="0" width="522" border="0">
</table>
<table bgcolor=#000000 width=522 border=0 cellpadding=2 cellspacing=0>
<tr>
<td width="522" height="23" bgcolor=#231d53 colspan=1>
<font color=#ffffff  face="arial, helvetica" size="2">
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;System Information
</font>
</td>   
</tr>
<tr><td><font face="arial, helvetica" size="2"><pre>
SysInfo    : $sysname
&nbsp;   $uptime

OS	  : $sysos
RAM	: $memory MB (approx.)
Swap	: $swap MB (approx.)
</pre></font></td></tr>
</table>
EndHTML
;

if ( $showdrivemap == 1 ) {
	if ( $rootdev ne "" or $homedev ne "" or $usrdev ne "" or $vardev ne "" ) {
		print "<table bgcolor=#000000 width=522 border=0 cellpadding=2 cellspacing=0>\n";
		print "<tr>\n";
		print "<td width=\"522\" height=\"23\" bgcolor=#231d53 colspan=6>\n";
		print "<font color=#ffffff  face=\"arial, helvetica\" size=\"2\">\n";
		print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Drive map\n";
		print "</font>\n";
		print "</td>\n";
		print "</tr>\n";
		print "<tr>\n";
		print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Filesystem</b></font></td>\n";
		print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Mount</b></font></td>\n";
		print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Use</b></font></td>\n";
		print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Used</b></font></td>\n";
		print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Avail</b></font></td>\n";
		print "<td align=center><font face=\"arial, helvetica\" size=\"2\"><b>Size</b></font></td>\n";
	}
	if ( $rootdev ne "" ) {
		print "<tr>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/dev/$rootdev</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">\n";
		print "<img src=\"$image\" height=10 width=$cutroot> $cutroot\%</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutrootused\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutrootavail\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutroottotal\K</font></td>\n";
		print "</tr>\n";
	}
	if ( $homedev ne "" ) {
		print "<tr>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/dev/$homedev</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/home</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">\n";
		print "<img src=\"$image\" height=10 width=$cuthome> $cuthome\%</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cuthomeused\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cuthomeavail\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cuthometotal\K</font></td>\n";
		print "</tr>\n";
	}
	if ( $usrdev ne "" ) {
		print "<tr>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/dev/$usrdev</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/usr</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">\n";
		print "<img src=\"$image\" height=10 width=$cutusr> $cutusr\%</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutusrused\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutusravail\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutusrtotal\K</font></td>\n";
		print "</tr>\n";
	}
	if ( $vardev ne "" ) {
		print "<tr>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/dev/$vardev</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">/var</font></td>\n";
		print "<td align=left><font face=\"arial, helvetica\" size=\"2\">\n";
		print "<img src=\"$image\" height=10 width=$cutvar> $cutvar\%</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutvarused\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutvaravail\K</font></td>\n";
		print "<td align=right><font face=\"arial, helvetica\" size=\"2\">$cutvartotal\K</font></td>\n";
		print "</tr>\n";
	}
	print "</table></p>";
}

if ( $showwhat == 1 ) {
	print "<p>\n";
	print "<table bgcolor=#000000 width=522 border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td width=\"522\" height=\"23\" bgcolor=#231d53 colspan=1>\n";
	print "<font color=#ffffff  face=\"arial, helvetica\" size=\"2\">\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Who's doing What\n";
	print "</font>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr><td><font face=\"arial, helvetica\" size=\"2\"><pre>\n";
	open(INF, "$tmpw");
		@w = <INF>;
	close(INF);
	print "\n@w";
	print "</pre></font></td></tr></table>";
}

if ( $showhogs == 1 ) {
	print "<table bgcolor=#000000 width=522 border=0 cellpadding=2 cellspacing=0>\n";
	print "<tr>\n";
	print "<td width=\"522\" height=\"23\" bgcolor=#231d53 colspan=1>\n";
	print "<font color=#ffffff  face=\"arial, helvetica\" size=\"2\">\n";
	print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Resource Hogs\n";
	print "</font>\n";
	print "</td>\n";
	print "</tr>\n";
	print "<tr><td><font face=\"arial, helvetica\" size=\"2\"><pre>\n";
	open(INF, "$tmptop");
		@top = <INF>;
	close(INF);
	print "\n@top\n";
	print "</pre></font></td></tr></table></p>";
}
print "<hr><font face=\"arial\" size=1>Output produced by <a href=\"http://www.weirdo.net/scripts/\">SysWatch v1.0</a></font>\n";
print "</body></html>\n";
`rm $tmptop`;
`rm $tmpw`;
